package animation;

import java.awt.BorderLayout;
import java.awt.GraphicsConfiguration;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.swing.JFrame;
import javax.swing.JLabel;

import com.sun.j3d.utils.universe.SimpleUniverse;

public class AnimatedScene implements KeyListener {

	private SimpleUniverse u;
	private Canvas3D canvas;
	protected JLabel label;
	private final String labelText = "FPS: ";
	
	public static void main(String args[]) {
		new AnimatedScene();
	}
	
	public AnimatedScene() {

		JFrame frame = new JFrame();
		frame.setSize(512, 512);
		frame.setLayout(new BorderLayout());
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		label = new JLabel(labelText);
		frame.add(label, BorderLayout.SOUTH);
		

	    GraphicsConfiguration config = 
	      SimpleUniverse.getPreferredConfiguration();

	    canvas = new Canvas3D(config);
	    frame.add(canvas, BorderLayout.CENTER);

	    u = new SimpleUniverse(canvas);
	    u.getViewingPlatform().setNominalViewingTransform();
	    
	    frame.setVisible(true);
	}
	
	public SimpleUniverse getSimpleUniverse() {
		return u;
	}
	
	public void enableAnimationBehavior(UpdateListener listener) {
		
		BranchGroup animationBranch = new BranchGroup();
		AnimationInterpolator animationInterpolator = 
				new AnimationInterpolator(listener);
		animationInterpolator.setSchedulingBounds(Constants.INFINITE_BOUNDS);
		animationBranch.addChild(animationInterpolator);
		u.addBranchGraph(animationBranch);
	}
	
	public void enableKeyListener() {
		canvas.addKeyListener(this);
	}

	public void keyPressed(KeyEvent arg0) {
		
	}

	public void keyReleased(KeyEvent arg0) {
		
	}

	public void keyTyped(KeyEvent arg0) {
		
	}

}
