package animation;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.AxisAngle4f;

import com.sun.j3d.utils.geometry.ColorCube;

public class Example extends AnimatedScene implements UpdateListener{

	private TransformGroup transformGroup; 
	private float rotationDegreesPerSecond = 5.0f;
	
	public static void main(String args[]) {
		new Example();
	}
	
	public Example() {
		enableAnimationBehavior(this);
		createContentBranch();
	}
	
	public void createContentBranch() {
		BranchGroup contentRoot = new BranchGroup();
		
		transformGroup = new TransformGroup();
		transformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		contentRoot.addChild(transformGroup);
		
		ColorCube colorCube = new ColorCube(0.3);
		transformGroup.addChild(colorCube);
		
		getSimpleUniverse().addBranchGraph(contentRoot);
	}
	
	long animationStartTimeMillis = -1;
	public void updateSceneGraph() {
		long currentFrameTimeMillis = System.currentTimeMillis();
		if(animationStartTimeMillis == -1)
			animationStartTimeMillis = currentFrameTimeMillis;
		long animationTimeMillis = currentFrameTimeMillis - animationStartTimeMillis;
		updateSceneGraph(animationTimeMillis);
	}
	
	public void updateSceneGraph(long animationTimeMillis) {
		float animationTimeSeconds = animationTimeMillis / 1000.0f;
		float currentAngleDegrees = (rotationDegreesPerSecond * animationTimeSeconds) % 360.0f;
		float currentAngleRadians = (float)Math.toRadians(currentAngleDegrees);
		Transform3D transform3D = new Transform3D();
		transform3D.setRotation(new AxisAngle4f(Constants.Y_AXIS, currentAngleRadians));
		transformGroup.setTransform(transform3D);
	}
}

