package animation;

import javax.media.j3d.BranchGroup;

import com.sun.j3d.utils.geometry.ColorCube;

public class FPSExample extends AnimatedScene implements UpdateListener{

	public static void main(String args[]) {
		new FPSExample();
	}
	
	public FPSExample() {
		enableAnimationBehavior(this);
		createContentBranch();
	}
	
	public void createContentBranch() {
			
			BranchGroup contentRoot = new BranchGroup();
			contentRoot.addChild(new ColorCube(0.3));
			getSimpleUniverse().addBranchGraph(contentRoot);
		}
	
	
	
	long previousFrameTime = -1;
	
	public void updateSceneGraph() {
		
		long currentFrameTime = System.currentTimeMillis();
		if(previousFrameTime != -1) {
			int interFrameTime = (int)(currentFrameTime - previousFrameTime);
			int framesPerSecond = 1000 / interFrameTime;
			label.setText(framesPerSecond+" FPS");
		}
		previousFrameTime = currentFrameTime;
	}
}

