package animation;

import javax.media.j3d.Appearance;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;

import com.sun.j3d.utils.geometry.Sphere;

public class Target extends BranchGroup {
	
	private Point3f location = null;
	private float radius = 0.0f;
	
	public Target(float x, float y, float z, float radius) {
		
		setCapability(BranchGroup.ALLOW_DETACH);
		Transform3D targetTransform = new Transform3D();
		targetTransform.setTranslation(new Vector3f(x, y, z));
		TransformGroup targetTG = new TransformGroup(targetTransform);
		addChild(targetTG);
		
		Sphere target = new Sphere(radius, new Appearance());
		targetTG.addChild(target);
		
		location = new Point3f(x, y, z);
		this.radius = radius;
	}
	
	public Point3f getLocation() {
		return location;
	}
	
	public float getRadius() {
		return radius;
	}
}
